package cn.hhj.controller;

import com.netflix.hystrix.contrib.javanica.annotation.HystrixCommand;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

@RestController
public class UploadRest {
    @PostMapping("/upload")
    @HystrixCommand(fallbackMethod="uploadFallback")
    public String upload(@RequestParam("photo") MultipartFile photo){
        if (photo != null) { // 表示现在已经有文件上传了
            System.out.println("【文件名称】" + photo.getOriginalFilename() );
            System.out.println("【文件大小】" + photo.getSize());
        }
        return "QingSe-file-" + System.currentTimeMillis() + ".jpg";
    }
    public String uploadFallback(@RequestParam("photo") MultipartFile photo) {
        return "error.jpg" ;
    }

}
