package cn.hhj.service.impl;

import cn.hhj.channel.OutputProcess;
import cn.hhj.service.IMessageProvider;
import cn.hhj.vo.Company;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.cloud.stream.annotation.EnableBinding;
import org.springframework.messaging.MessageChannel;
import org.springframework.messaging.support.MessageBuilder;



@EnableBinding(OutputProcess.class)
public class MessageProviderImpl implements IMessageProvider {

    @Qualifier(OutputProcess.OUTPUT)
    @Autowired
    private MessageChannel output;

    @Override
    public void send(Company company) {
        //创建并发送消息
        this.output.send(MessageBuilder.withPayload(company).build());
    }
}
